package jp.savethememory.manage.action;

import javax.annotation.Resource;

import jp.savethememory.manage.dto.UserDto;
import jp.savethememory.manage.entity.UserInfo;
import jp.savethememory.manage.form.LoginForm;
import jp.savethememory.manage.service.UserInfoService;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.seasar.struts.annotation.ActionForm;
import org.seasar.struts.annotation.Execute;



/**
 * LoginActionクラス
 *
 */
public class LoginAction {

	public String message = null;

	/** アクションフォーム */
	@Resource
	@ActionForm
	protected LoginForm loginForm;

	/** 認証情報を格納するためのセッションスコープのDTO  */
	@Resource
	protected UserDto userDto = null;

	/**　ログイン失敗時のメッセージ */
	private static final String LOGIN_ERROR_MESSAGE = "認証に失敗しました。アカウント又はパスワードが間違っています。";

	@Resource
	protected UserInfoService userInfoService;

	protected Log LOGGER = LogFactory.getLog(LoginAction.class);

	/** ログイン画面を表示する実行メソッド */
	@Execute(validator = false)
	public String index(){
		String returnPage = "loginForm.jsp";

		//セッションが既に存在する場合はログイン画面を表示せず次の画面へ遷移させる
		if(this.userDto != null){
			if(this.userDto.account != null){
				returnPage = "/tbShinseiSearch?redirect=true";
			}
		}

		return returnPage;

	}

   /** ログインボタンがクリックされた際に呼び出される実行メソッド */
	@Execute(validator = true, input = "loginForm.jsp")
	public String login(){
		String returnPage;

		LOGGER.debug("login start ----------------------");
		LOGGER.debug("login account:" + loginForm.account);
		//ログイン画面で入力されたアカウントとパスワードの認証
		UserInfo userInfo = userInfoService.getUserInfo(
				loginForm.account,loginForm.password);
		if(userInfo != null){
			//ログイン成功
			//sessionに情報を登録
			userDto.account = userInfo.getAccount();

			userDto.shichousonCode = userInfo.getShichousonCode();
			userDto.shichousonName = userInfo.getShichousonName();


			//ログイン後に表示する申請検索画面へ遷移
			LOGGER.debug("login success.");
			returnPage = "/tbShinseiSearch?redirect=true";
		}else{
			//ログイン失敗なので、もう一度ログイン画面に遷移
			this.message = LOGIN_ERROR_MESSAGE;
			LOGGER.debug("login failure.");
			returnPage = "loginForm.jsp";
		}

		LOGGER.debug("login end----------------------");
		return returnPage;
	};

}
