package jp.savethememory.manage.service;

import java.io.IOException;
import java.io.InputStream;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.amazonaws.AmazonServiceException;
import com.amazonaws.ClientConfiguration;
import com.amazonaws.auth.BasicAWSCredentials;
import com.amazonaws.services.s3.AmazonS3;
import com.amazonaws.services.s3.AmazonS3Client;
import com.amazonaws.services.s3.model.GetObjectRequest;
import com.amazonaws.services.s3.model.S3Object;

/**
 *
 * @version 0.1
 * @since 2013/01/25
 */
public class StorageS3Service {

	protected Log LOGGER = LogFactory.getLog(StorageS3Service.class);

	private final String ACCESSKEY = "dummy";

	private final String SERCRETKEY = "dummy";

	private final String PROXY_HOST = null;

	private final int PROXY_PORT = 8080;

	private final String PROXY_USERNAME = null;

	private final String PROXY_PASSWORD = null;
	private AmazonS3 s3;

	public StorageS3Service() throws IOException {
		s3 = createS3Service();
	}

	/**
	 * ファイルをｓ３からダウンロードするメソッド
	 *
	 * @param bucketName
	 * @param key
	 *            ファイルキー
	 * @return
	 * @throws IOException
	 */
	public InputStream downloadFile(String bucketName, String key) throws IOException {
		try {
			// 指定したファイルのオブジェクトを取得
			S3Object fileObject = s3.getObject(new GetObjectRequest(bucketName, key));
			InputStream fileIn = fileObject.getObjectContent();

			return fileIn;
		} catch (AmazonServiceException ase) {
			LOGGER.error("サーバエラー：ダウンロードに失敗");
			throw ase;
		}
	}

	/**
	 * AmazonS3のオブジェクトを生成する
	 *
	 * @return
	 * @throws IOException
	 */
	private AmazonS3 createS3Service() throws IOException {
		BasicAWSCredentials credentials = new BasicAWSCredentials(ACCESSKEY, SERCRETKEY);
		ClientConfiguration configuration = new ClientConfiguration();
		if (null != PROXY_HOST) {
			configuration.setProxyHost(PROXY_HOST);
			configuration.setProxyPort(PROXY_PORT);
			if (null != PROXY_USERNAME) {
				configuration.setProxyUsername(PROXY_USERNAME);
				configuration.setProxyPassword(PROXY_PASSWORD);
			}

		}
		AmazonS3 s3 = new AmazonS3Client(credentials, configuration);

		return s3;
	}

}
