package jp.savethememory.manage.service;

import java.util.List;

import jp.savethememory.manage.entity.TbKoukaiSyashin;
import jp.savethememory.manage.entity.TbSyashin;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class TbKoukaiSyashinService extends AbstractService<TbKoukaiSyashin> {

	protected Log LOGGER = LogFactory.getLog(TbKoukaiSyashinService.class);

	public TbKoukaiSyashin findById(Long contentsId) {
		return select().id(contentsId).getSingleResult();
	}
	
	public List<TbKoukaiSyashin> findByShinseiNo(String shinseiNo) {
		LOGGER.debug("start-----.");
		List<TbKoukaiSyashin> results = null;
		if (shinseiNo == null || ("").equals(shinseiNo)) {
			return results;
		}

		results = jdbcManager.from(TbKoukaiSyashin.class).where("shinseiNo = ?", Long.valueOf(shinseiNo))
				.orderBy("fileName").getResultList();
		LOGGER.debug("end-----.");
		return results;
	}
	
	/**
	 * 指定された申請Noの写真のquanpUploadStatusを指定された状態に更新する。
	 * 
	 * @param shinseiNo
	 * @param quanpUploadStatusNeed
	 */
	public void updateQuanpUploadStatus(String shinseiNo, String quanpUploadStatus) {
		LOGGER.debug("start-----.");
		String sql = "update tb_koukai_syashin set quanp_upload_status = ? where shinsei_no = ?";
		int[] count = jdbcManager.updateBatchBySql(
				sql, 
				Integer.class, 
				Long.class)
				.params(Integer.valueOf(quanpUploadStatus), Long.valueOf(shinseiNo))
				.execute();
		if (count != null && count.length != 0) {
			LOGGER.debug("update count:" + count[0] + " quanpUploadStatus:" + quanpUploadStatus);
		}
		LOGGER.debug("end-----.");
	}
	
}
