package jp.savethememory.manage.service;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import jp.savethememory.manage.entity.TbShichouson;
import jp.savethememory.manage.entity.TbSyashin;


/**
 * 市町村テーブルに対する操作を行うクラス
 *
 */
public class TbShichousonService extends AbstractService<TbShichouson> {

	protected Log LOGGER = LogFactory.getLog(TbShichousonService.class);

	public TbShichouson findById(String shichousonCode) {
        return select().id(shichousonCode).getSingleResult();
    }

    /**
     *	quanpのパスワードを取得します。
     * @param account
     * @return
     */
    public String getPassword(String account) {
         //TODO 暗号化されて永続化されるはずなので、復号化が必要になる
    	String password = null;
    	if(account == null || ("").equals(account)){
    		LOGGER.debug("account is null.");
    	}


    	 TbShichouson entity =
    		 select()
    		 .where("quanpId = ?",account)
    		 .getSingleResult();
    	 password = entity.getAdminPassword();
    	 password = password.trim();
    	 return password;
    }
	/**
	 * tb_syashinから最新の返却枚数を取得し、tb_shichousonのreturn_countに更新します。
	 *
	 * @param quanpId
	 */

	public void updateReturnCount(String quanpId) {
		// 最新の返却枚数を取得します。
		long returnCount = jdbcManager.from(TbSyashin.class).where("quanp_id = '" + quanpId + "' and return_flg = true").getCount();
		// 取得した返却枚数を市町村テーブルに更新します。
		jdbcManager.updateBySql("update tb_shichouson set return_count = ? where quanp_id = ?", Long.class, String.class).params(returnCount, quanpId).execute();

	}

}