package jp.savethememory.manage.service;

import jp.savethememory.manage.entity.TbShichouson;
import jp.savethememory.manage.entity.UserInfo;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.seasar.extension.jdbc.JdbcManager;
import org.seasar.extension.jdbc.where.SimpleWhere;
import org.seasar.struts.annotation.Execute;

/**
 * 認証ロジックになります。
 *
 *
 */
public class UserInfoService {

	public JdbcManager jdbcManager;

	protected Log LOGGER = LogFactory.getLog(UserInfoService.class);

	/**
	 * 指定されたアカウントがSTMの利用自治体のアカウントであることを確認する 自治体コードも特定したい。
	 * さらに、quanpで認証し、認証がOKであれば、UserInfoを生成して返却する。 該当しない場合はUserInfoはnullで返す。
	 *
	 * @param account
	 *            ログインしようとしているアカウント
	 * @param password
	 *            　ログインしようとしているパスワード
	 * @return UserInfo　認証できた場合は返る。認証できなかった場合はnullが返る。
	 */
	@Execute
	public UserInfo getUserInfo(String account, String password) {
		UserInfo userInfo = isExistDB(account, password);

		return userInfo;
	}

	/**
	 * 指定されたアカウントがSTMの利用自治体のアカウントであることを確認する 自治体コードも特定したい。
	 * さらに、quanpで認証し、認証がOKであれば、UserInfoを生成して返却する。 該当しない場合はUserInfoはnullで返す。
	 * */
	@Execute
	protected UserInfo isExistDB(String account, String password) {
		UserInfo userInfo = null;

		// アカウントが存在するかだけでなく、ローカルのデータベースサーバーで認証を行なうコードに変更
		TbShichouson result = jdbcManager
				.from(TbShichouson.class)
				.where(new SimpleWhere().eq("quanpId", account).eq(
						"adminPassword", password)).getSingleResult();

		if (result != null) {
			userInfo = new UserInfo();
			userInfo.setAccount(account);
			userInfo.setShichousonCode(result.getShichousonCode());
			userInfo.setShichousonName(result.getShichousonName());
		}
		if (userInfo != null) {
			LOGGER.debug(account + " is Exsits in STMDB.");
		}
		return userInfo;
	}
}
