package jp.savethememory.manage.util;

import java.util.regex.Pattern;

/**
 * コード定義をまとめています。
 *
 */
public interface CommonDefine {


	/** 申請テーブルの申請状態 申請中 */
	public final static String	SHINSEI_STATUS_SHINSEICHU = "0";
	public final static String	SHINSEI_STATUS_SHINCEICHU_LABEL ="申請中";
	/** 申請テーブルの申請状態 引渡済 */
	public final static String 	SHINSEI_STATUS_HIKIWATASHIZUMI = "1";
	public final static String	SHINSEI_STATUS_HIKIWATASHIZUMI_LABEL ="引渡済";

	/** 申請テーブルのデジタル返却ステータス
	 * 個人のqunapアカウントにデジタルデータを返却したかどうか
	 * 未返却（テーブル上nullの場合も未返却と表示します。）
	 *  */
	public final static String	DIGITAL_STATUS_NOT_RETURN = "0"; //未返却
	/** 申請テーブルのデジタル返却ステータス
	 * 個人のqunapアカウントにデジタルデータを返却したかどうか
	 * 返却済
	 *  */
	public final static String	DIGITAL_STATUS_RETURN = "1";	//返却済

	/** 申請テーブルの引渡手段 手渡し及び、quanpでのデジタルデータの返却 */
	public final static int 		HIKIWATASHI_SYUDAN_HAND = 0;
	public final static String	HIKIWATASHI_SYUDAN_HAND_LABEL ="手渡およびquanp";
	/** 申請テーブルの引渡手段 配送及び、quanpでのデジタルデータの返却 */
	public final static int 		HIKIWATASHI_SYUDAN_SEND = 1;
	public final static String	HIKIWATASHI_SYUDAN_SEND_LABEL ="配送およびquanp";

	/** 性別	（申請テーブル）男性 */
	public final static int		SEX_MAN_MALE = 0;
	/** 性別	（申請テーブル）女性 */
	public final static int 		SEX_FEMALE = 1;


	/** クオンプIDの自動発行ステータス（申請テーブル）
	 * tb_shinsei.quanp_id_status
	 * メアドがある場合は、STM側からquanp_idを取得します。
	 * nullは"0"として扱います */
	//TODO ENUM化する、もしくはintに変更する方が良い。
	/** 申請テーブルのクオンプIDの発行ステータス：取得対象外（メアド無し）*/
	public final static String		QUANP_ID_STATUS_UNNEEDED = "0";
	/** 申請テーブルのクオンプIDの発行ステータス：取得成功（以前取得済みのIDを使いまわす場合もこれ）*/
	public final static String		QUANP_ID_STATUS_SUCCESS = "1";
	/** 申請テーブルのクオンプIDの発行ステータス：取得失敗(STMMまたは、QuanpCoreのエラー) */
	public final static String		QUANP_ID_STATUS_FAILURE = "2";
	/** 申請テーブルのクオンプIDの発行ステータス：取得失敗(メールアドレスが既に利用されている) */
	public final static String		QUANP_ID_STATUS_FAILURE_DUPLICATE_MAIL = "3";
	/** 申請テーブルのクオンプIDの発行ステータス：取得失敗（クオンプIDが既に使われている） */
	public final static String		QUANP_ID_STATUS_FAILURE_DUPLICATE_ID = "4";
	/** 申請テーブルのクオンプIDの発行ステータス：取得失敗(メールアドレスが不正) */
	public static final String QUANP_ID_STATUS_FAILURE_INVALID_MAIL = "5";
	/** 申請テーブルのクオンプIDの発行ステータス：取得失敗（クオンプIDが不正） */
	public static final String QUANP_ID_STATUS_FAILURE_INVALID_ID = "6";

	/** 写真テーブルのクオンプへのデジタルデータのアップロードステータス：アップロード対象外
	 * メアド無し場合などqunapIDの発行ができていない場合
	 * DBがnullの場合も表示はアップロード対象外と表示します*/
	public final static String		QUANP_UPLOAD_STATUS_UNNEEDED = "0";
	/** 写真テーブルのクオンプへのデジタルデータのアップロードステータス：アップロード待ち*/
	public final static String 		QUANP_UPLOAD_STATUS_NEED = "1";
	/** 写真テーブルのクオンプへのデジタルデータのアップロードステータス：アップロード成功*/
	public final static String 		QUANP_UPLOAD_STATUS_SUCCESS = "2";
	/** 写真テーブルのクオンプへのデジタルデータのアップロードステータス：アップロード失敗*/
	public final static String 		QUANP_UPLOAD_STATUS_FAILURE = "3";
	/**	写真テーブルのデジタルデータのアップロードステータス：引渡し済み */
	public final static String 		QUANP_UPLOAD_STATUS_DOWNLOADED = "4";

	//年月日有ファイル名（1枚スキャン時）
	public static final Pattern FILE_NAME_PATTERN1 = Pattern.compile("^[0-9]{2}[01][0-9][0-3][0-9]_[A-Z]{2,3}-[A-Z]-[0-9]{7}-[0-9]{7}\\.jpg$");
	//年月日有ファイル名（8枚スキャン時）
	public static final Pattern FILE_NAME_PATTERN2 = Pattern.compile("^[0-9]{2}[01][0-9][0-3][0-9]_[A-Z]{2,3}-[A-Z]-[0-9]{7}-[0-9]{7}-[1-8]\\.jpg$");
	//年月日無しファイル名
	public static final Pattern FILE_NAME_PATTERN3 = Pattern.compile("^[A-Z]{2,3}-[A-Z]-[0-9]{7}-[0-9]{7}\\.jpg$");
	//ファイル名拡張子(.jpg)
	public static final int FILE_NAME_EXTENSION_LENGTH = 4;
	//アルバム判断のために切り出すサフィックスの長さ　ファイル名（1枚スキャン時）
	public static final int FILE_NAME_SUFFIX_LENGTH = 11;
	//アルバム判断のために切り出すサフィックスの長さ　ファイル名（8枚スキャン時）
	public static final int FILE_NAME_EIGHT_SUFFIX_LENGTH = 13;
	//ファイル名の日付部分の長さ
	public static final int FILE_NAME_SUBSTRING_DATE_LENGTH = 7;


	/**
	 * システム内で使っているプロパティファイル名
	 */
	public final static String PROPERTIES_STMM_FILE_NAME = "stmm";
//	public final static String PROPERTIES_STMM_KEY_QUANP_CORE_END_POINT = "quanp_core_api_end_point";
	public static final String PROPERTIES_STMM_KEY_QUANP_CORE_TIME_OUT = "quanp_core_time_out";
	public static final String PROPERTIES_STMM_KEY_QUANP_CORE_AGENT = "quanp_core_agent";
	public static final String PROPERTIES_STMM_KEY_QUANP_CORE_APPID = "quanp_core_appid";
	public static final String PROPERTIES_STMM_KEY_QUANP_RETURN_PLACE = "quanp_core_return_place";
	public static final String PROPERTIES_STMM_KEY_QUANP_CORE_HOST = "quanp_core_host";
	public static final String PROPERTIES_STMM_KEY_QUANP_CORE_PROTOCOL = "quanp_core_protocol";
	public final static String PROPERTIES_STMM_KEY_IMG_THUMBNAIL_PREFIX = "thumbnail_prefix";
	public final static String PROPERTIES_STMM_KEY_IMG_ORIGINAL_PREFIX = "original_prefix";
	public final static String PROPERTIES_STMM_KEY_IMG_VIEW_PREFIX = "view_prefix";
	public final static String PROPERTIES_STMM_KEY_IMG_SUFFIX = "img_suffix";
	public final static String PROPERTIES_STMM_MAX_NUMBER_OF_SHINSEI_IN_A_PAGE = "max_number_of_shinsei_in_a_page";
	public final static String PROPERTIES_STMM_KEY_FET_ROOT_PATH = "fet_files_root_path";
	public final static String PROPERTIES_STMM_KEY_FET_BACKUP_PATH = "fet_files_backup_path";

}
