//
//Copyright 2009 RICOH IT Solutions Inc. All Rights Reserved.
package jp.savethememory.manage.util;


import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.URLEncoder;
import java.util.ResourceBundle;

import javax.servlet.http.HttpServletResponse;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;


import org.apache.commons.httpclient.DefaultHttpMethodRetryHandler;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpConnectionManager;
import org.apache.commons.httpclient.HttpException;
import org.apache.commons.httpclient.SimpleHttpConnectionManager;
import org.apache.commons.httpclient.methods.DeleteMethod;
import org.apache.commons.httpclient.methods.GetMethod;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.commons.httpclient.methods.PutMethod;
import org.apache.commons.httpclient.params.HttpConnectionManagerParams;
import org.apache.commons.httpclient.params.HttpMethodParams;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;


/**
* 新業務 API I/Fクラス
*
* @since 1.0
*/
public class NgmApiRequester {

 private static String REQUESTPROPERTY_USER_AGENT_TITLE = "User-Agent";

 private static String REQUESTPROPERTY_CONTENT_TYPE_TITLE = "Content-Type";
 private static String REQUESTPROPERTY_CONTENT_TYPE = "application/atom+xml;type=entry;charset=\"utf-8\"";

 private static String REQUESTPROPERTY_ACCEPT_LANGUAGE_TITLE = "Accept-Language";
 private static String REQUESTPROPERTY_ACCEPT_LANGUAGE = "ja;q=0.7,en;q=0.3";



 protected Log LOGGER = LogFactory.getLog(NgmApiRequester.class);
 private static String APPID;
 final static private int TIMEOUT;
 final static private String ENDPOINT = null;
 final static private String AGENT;
 final static private String PROXYHOST;
 final static private int PROXYPORT;
 final static private ResourceBundle PROPERTIES;

 private int responceCode;
 private String responce;
 //private String contentType;
 private String uuid;



	static {
		PROPERTIES = ResourceBundle.getBundle(CommonDefine.PROPERTIES_STMM_FILE_NAME);
//		ENDPOINT = PROPERTIES.getString(CommonDefine.PROPERTIES_STMM_KEY_QUANP_CORE_END_POINT);
		TIMEOUT = Integer.parseInt(PROPERTIES
				.getString(CommonDefine.PROPERTIES_STMM_KEY_QUANP_CORE_TIME_OUT));
		AGENT = PROPERTIES.getString(CommonDefine.PROPERTIES_STMM_KEY_QUANP_CORE_AGENT);
		APPID = PROPERTIES.getString(CommonDefine.PROPERTIES_STMM_KEY_QUANP_CORE_APPID);
		PROXYHOST = null;
		PROXYPORT = 0;
	}

 /**
 * メールアドレスチェックAPI呼び出し
 *
 * @param mailAddr
 * @return
 */
 public boolean checkMailAddr( String mailAddr ) {
	  boolean canUse = false;
     responceCode = 0;

     String encodedMailAddr;
     try {
        encodedMailAddr = URLEncoder.encode(mailAddr, "UTF-8");
     } catch (UnsupportedEncodingException e) {
        //無視
        return canUse;
     }

     String url = ENDPOINT + "/" + "mailaddr/checkEnabled?mailAddr=" + encodedMailAddr;
     GetMethod getMethod = new GetMethod( url );
     LOGGER.debug( url );

     getMethod.getParams().setParameter(HttpMethodParams.RETRY_HANDLER,new DefaultHttpMethodRetryHandler(0,false));

     //ヘッダ
     getMethod.setRequestHeader(REQUESTPROPERTY_USER_AGENT_TITLE, AGENT);
     getMethod.setRequestHeader(REQUESTPROPERTY_CONTENT_TYPE_TITLE, REQUESTPROPERTY_CONTENT_TYPE);
     getMethod.setRequestHeader(REQUESTPROPERTY_ACCEPT_LANGUAGE_TITLE, REQUESTPROPERTY_ACCEPT_LANGUAGE);

     HttpConnectionManagerParams params = new HttpConnectionManagerParams();
     params.setConnectionTimeout(TIMEOUT);      // コネクションタイムアウトmsec
     params.setSoTimeout(TIMEOUT);            // ソケットタイムアウトmsec
     HttpConnectionManager manager = new SimpleHttpConnectionManager();
     manager.setParams(params);

     HttpClient httpclient = new HttpClient(manager);

     if( PROXYHOST != null ) {
        if( !PROXYHOST.isEmpty() ) {
           httpclient.getHostConfiguration().setProxy(PROXYHOST, PROXYPORT);
        }
     }

     try {
        responceCode = httpclient.executeMethod(getMethod);
        LOGGER.info("responceCode:" + responceCode );
         if(responceCode == HttpServletResponse.SC_OK){
        	 canUse = true;
        }
     } catch (HttpException e) {
        LOGGER.error(e.getMessage());
     } catch (IOException e) {
         LOGGER.error(e.getMessage());
     } finally  {
        getMethod.releaseConnection();
     }

     return canUse;
 }


 /**
 * QuanpIdチェックAPI呼び出し
 *
 * @param quanpId
 * @return
 */
 public boolean checkQuanpId( String quanpId ) {
	  boolean isUsed = false;
    responceCode = 0;

    String encodedQuanpId;
    try {
       encodedQuanpId = URLEncoder.encode(quanpId, "UTF-8");
    } catch (UnsupportedEncodingException e) {
       //無視
       return isUsed;
    }

    String url = ENDPOINT + "/" + "user/checkEnabled?quanpId=" + encodedQuanpId;
    GetMethod getMethod = new GetMethod( url );
    LOGGER.debug( url );
    getMethod.getParams().setParameter(HttpMethodParams.RETRY_HANDLER,new DefaultHttpMethodRetryHandler(0,false));

    //ヘッダ
    getMethod.setRequestHeader(REQUESTPROPERTY_USER_AGENT_TITLE, AGENT);
    getMethod.setRequestHeader(REQUESTPROPERTY_CONTENT_TYPE_TITLE, REQUESTPROPERTY_CONTENT_TYPE);
    getMethod.setRequestHeader(REQUESTPROPERTY_ACCEPT_LANGUAGE_TITLE, REQUESTPROPERTY_ACCEPT_LANGUAGE);

    HttpConnectionManagerParams params = new HttpConnectionManagerParams();
    params.setConnectionTimeout(TIMEOUT);      // コネクションタイムアウトmsec
    params.setSoTimeout(TIMEOUT);            // ソケットタイムアウトmsec
    HttpConnectionManager manager = new SimpleHttpConnectionManager();
    manager.setParams(params);

    HttpClient httpclient = new HttpClient(manager);

    if( PROXYHOST != null ) {
       if( !PROXYHOST.isEmpty() ) {
          httpclient.getHostConfiguration().setProxy(PROXYHOST, PROXYPORT);
       }
    }

    try {
       responceCode = httpclient.executeMethod(getMethod);
       LOGGER.info("responceCode:" + responceCode );
       if(responceCode == HttpServletResponse.SC_OK){
       	isUsed = true;
        }
    } catch (HttpException e) {
       LOGGER.error(e.getMessage());
    } catch (IOException e) {
        LOGGER.error(e.getMessage());
    } finally  {
       getMethod.releaseConnection();
    }

    return isUsed;
 }

 /**
 * 一時登録
 *
 * @param quanpId
 * @return
 */
 public void  registTempQuanpId( String quanpId ,String password , String emailAddr , String nickName , boolean mailEnable ) {

    responceCode = 0;
    if( quanpId == null || quanpId.isEmpty() ) {
        return;
     }
     if( password == null || password.isEmpty() ) {
        return;
     }
     if( nickName == null || nickName.isEmpty() ) {
        return;
     }

    String mailEnableString;
    if( mailEnable == true ) {
       mailEnableString = "1";
    } else {
       mailEnableString = "0";
    }

    String encodedMailAddr;
    String encodedQuanpId;
    String encodedPassword;
    String encodedNickName;
    try {
       encodedMailAddr = URLEncoder.encode(emailAddr, "UTF-8");
       encodedQuanpId  = URLEncoder.encode(quanpId, "UTF-8");
       encodedPassword = URLEncoder.encode(password, "UTF-8");
       encodedNickName = URLEncoder.encode(nickName, "UTF-8");
    } catch (UnsupportedEncodingException e) {
       //無視
       return;
    }

    String url = ENDPOINT + "/" + "user?"
                            + "appId=" + APPID
                            + "&quanpId=" + encodedQuanpId
                            + "&password=" + encodedPassword
                            + "&emailAddr=" + encodedMailAddr
                            + "&nickName=" + encodedNickName
                            + "&mailEnable=" + mailEnableString
                            + "&agreement=" + "1";

    LOGGER.debug( url );

    PostMethod postMethod = new PostMethod( url );
    postMethod.getParams().setParameter(HttpMethodParams.RETRY_HANDLER,new DefaultHttpMethodRetryHandler(0,false));

    //ヘッダ
    postMethod.setRequestHeader(REQUESTPROPERTY_USER_AGENT_TITLE, AGENT);
    postMethod.setRequestHeader(REQUESTPROPERTY_CONTENT_TYPE_TITLE, REQUESTPROPERTY_CONTENT_TYPE);
    postMethod.setRequestHeader(REQUESTPROPERTY_ACCEPT_LANGUAGE_TITLE, REQUESTPROPERTY_ACCEPT_LANGUAGE);

    HttpConnectionManagerParams params = new HttpConnectionManagerParams();
    params.setConnectionTimeout(TIMEOUT);      // コネクションタイムアウトmsec
    params.setSoTimeout(TIMEOUT);            // ソケットタイムアウトmsec
    HttpConnectionManager manager = new SimpleHttpConnectionManager();
    manager.setParams(params);

    HttpClient httpclient = new HttpClient(manager);

    if( PROXYHOST != null ) {
       if( !PROXYHOST.isEmpty() ) {
          httpclient.getHostConfiguration().setProxy(PROXYHOST, PROXYPORT);
       }
    }

    try {
       responceCode = httpclient.executeMethod(postMethod);
   		LOGGER.info("responceCode:" + responceCode );

       BufferedReader reader = new BufferedReader(new InputStreamReader(
             postMethod.getResponseBodyAsStream()));

       String buffer = reader.readLine();
       while (null != buffer) {
          responce = responce + buffer;
          buffer = reader.readLine();
       }
       reader.close();

       LOGGER.debug("----------------");
       LOGGER.debug( responce );
       LOGGER.debug("----------------");

       if( responceCode == HttpServletResponse.SC_OK ) {
    	   LOGGER.info("responceCode:" + responceCode );
    	   if(responce.startsWith("null")){
    		   responce = responce.substring(4);
    	   }
          DocumentBuilderFactory  factory = DocumentBuilderFactory.newInstance();
          Document doc = null;
          try {
             DocumentBuilder builder;
             builder = factory.newDocumentBuilder();
             InputStream is = new ByteArrayInputStream(responce.getBytes());
             doc = builder.parse(is);
             is.close();

             Element root = doc.getDocumentElement();
             NodeList rootChildren = root.getChildNodes();

             for(int i =0;i<rootChildren.getLength();i++){
                // [entry]ノードを検索
                if (rootChildren.item(i).getNodeName().equals("entry")) {
                   NodeList entryNode = rootChildren.item(i).getChildNodes();
                   for (int j = 0; j < entryNode.getLength();j++) {
                      if (entryNode.item(j).getNodeName().equals("content")) {
                         NodeList contentNode = entryNode.item(j).getChildNodes();
                         for (int k = 0; k < contentNode.getLength();k++) {

                            if (contentNode.item(k).getNodeName().equals("span")) {
                               uuid = XMLUtilities.getText(contentNode.item(k));
                            }
                         }
                      }
                   }
                }
             }
          } catch (ParserConfigurationException e) {
          		LOGGER.error( "ParserConfigurationException" + e );
          } catch (SAXException e) {
          		LOGGER.error( "SAXException" + e );
          } catch (IOException e) {
          		LOGGER.error( "IOException" + e );
          }
      }

    } catch (HttpException e) {
    	LOGGER.error(e.getMessage());
    } catch (IOException e) {
    	LOGGER.error(e.getMessage());
    } finally  {
       postMethod.releaseConnection();
    }


 }

 /**
 * 本登録
 *
 * @param uuid
 * @return
 */
 public boolean registQuanpId() {
	 boolean isUsed = false;
    responceCode = 0;
    responce = new String();

    if( this.uuid == null || this.uuid.isEmpty() ) {
       return isUsed;
    }

    String url = ENDPOINT + "/" + "user/activation?appId=" + APPID
    + "&uuId=" + uuid;

    PutMethod putMethod = new PutMethod( url );

    LOGGER.debug( url );

    putMethod.getParams().setParameter(HttpMethodParams.RETRY_HANDLER,new DefaultHttpMethodRetryHandler(0,false));

    //ヘッダ
    putMethod.setRequestHeader(REQUESTPROPERTY_USER_AGENT_TITLE, AGENT);
    putMethod.setRequestHeader(REQUESTPROPERTY_CONTENT_TYPE_TITLE, REQUESTPROPERTY_CONTENT_TYPE);
    putMethod.setRequestHeader(REQUESTPROPERTY_ACCEPT_LANGUAGE_TITLE, REQUESTPROPERTY_ACCEPT_LANGUAGE);

    HttpConnectionManagerParams params = new HttpConnectionManagerParams();
    params.setConnectionTimeout(TIMEOUT);      // コネクションタイムアウトmsec
    params.setSoTimeout(TIMEOUT);            // ソケットタイムアウトmsec
    HttpConnectionManager manager = new SimpleHttpConnectionManager();
    manager.setParams(params);

    HttpClient httpclient = new HttpClient(manager);

    if( PROXYHOST != null ) {
       if( !PROXYHOST.isEmpty() ) {
          httpclient.getHostConfiguration().setProxy(PROXYHOST, PROXYPORT);
       }
    }

    try {
       responceCode = httpclient.executeMethod(putMethod);
       LOGGER.info("responceCode:" + responceCode );
       if(responceCode == HttpURLConnection.HTTP_OK){
       	isUsed = true;
       }
    } catch (HttpException e) {
    	LOGGER.error(e.getMessage());
    } catch (IOException e) {
    	LOGGER.error(e.getMessage());
    } finally  {
       putMethod.releaseConnection();
    }

    return isUsed;

 }


 /**
 * 一時登録削除
 *
 * @param uuid
 * @return
 */
 public void deleteTempQuanpId( String uuid ) {

    responceCode = 0;
    responce = new String();

    if( uuid == null || uuid.isEmpty() ) {
       return;
    }

    String url = ENDPOINT + "/" + "user?appId=" + APPID
    + "&uuId=" + uuid;

    DeleteMethod deleteMethod = new DeleteMethod( url );
    LOGGER.debug( url );

    deleteMethod.getParams().setParameter(HttpMethodParams.RETRY_HANDLER,new DefaultHttpMethodRetryHandler(0,false));

    //ヘッダ
    deleteMethod.setRequestHeader(REQUESTPROPERTY_USER_AGENT_TITLE, AGENT);
    deleteMethod.setRequestHeader(REQUESTPROPERTY_CONTENT_TYPE_TITLE, REQUESTPROPERTY_CONTENT_TYPE);
    deleteMethod.setRequestHeader(REQUESTPROPERTY_ACCEPT_LANGUAGE_TITLE, REQUESTPROPERTY_ACCEPT_LANGUAGE);

    HttpConnectionManagerParams params = new HttpConnectionManagerParams();
    params.setConnectionTimeout(TIMEOUT);      // コネクションタイムアウトmsec
    params.setSoTimeout(TIMEOUT);            // ソケットタイムアウトmsec
    HttpConnectionManager manager = new SimpleHttpConnectionManager();
    manager.setParams(params);

    HttpClient httpclient = new HttpClient(manager);

    if( PROXYHOST != null ) {
       if( !PROXYHOST.isEmpty() ) {
          httpclient.getHostConfiguration().setProxy(PROXYHOST, PROXYPORT);
       }
    }

    try {
       responceCode = httpclient.executeMethod(deleteMethod);
   	    LOGGER.info("responceCode:" + responceCode );
    } catch (HttpException e) {
    	LOGGER.error(e.getMessage());
    } catch (IOException e) {
    	LOGGER.error(e.getMessage());
    } finally  {
       deleteMethod.releaseConnection();
    }

    return;

 }
//
//
// /**
// * 利用規約取得
// *
// * @param quanpId
// * @return
// */
// public String getContractHtml() throws MalformedURLException, ProtocolException, IOException {
//
//    String contractHtml = new String();
//
//    responceCode = 0;
//
//    GetMethod getMethod = new GetMethod(ENDPOINT + "/" + "contract");
//
//    LOGGER.debug( ENDPOINT + "/" + "contract" );
//
//    getMethod.getParams().setParameter(HttpMethodParams.RETRY_HANDLER,new DefaultHttpMethodRetryHandler(0,false));
//
//    //ヘッダ
//    getMethod.setRequestHeader(REQUESTPROPERTY_USER_AGENT_TITLE, AGENT);
//    getMethod.setRequestHeader(REQUESTPROPERTY_CONTENT_TYPE_TITLE, REQUESTPROPERTY_CONTENT_TYPE);
//    getMethod.setRequestHeader(REQUESTPROPERTY_ACCEPT_LANGUAGE_TITLE, REQUESTPROPERTY_ACCEPT_LANGUAGE);
//
//    HttpConnectionManagerParams params = new HttpConnectionManagerParams();
//    params.setConnectionTimeout(TIMEOUT);      // コネクションタイムアウトmsec
//    params.setSoTimeout(TIMEOUT);            // ソケットタイムアウトmsec
//    HttpConnectionManager manager = new SimpleHttpConnectionManager();
//    manager.setParams(params);
//
//    HttpClient httpclient = new HttpClient(manager);
//
//    if( PROXYHOST != null ) {
//       if( !PROXYHOST.isEmpty() ) {
//          httpclient.getHostConfiguration().setProxy(PROXYHOST, PROXYPORT);
//       }
//    }
//
//    try {
//       responceCode = httpclient.executeMethod(getMethod);
//       LOGGER.debug("HTTP 戻り値:" + responceCode );
//
//       if( responceCode == HttpURLConnection.HTTP_OK) {
//          BufferedReader reader = new BufferedReader(new InputStreamReader(
//                getMethod.getResponseBodyAsStream()));
//
//          String buffer = reader.readLine();
//
//          while (null != buffer) {
//             contractHtml = contractHtml + buffer;
//             buffer = reader.readLine();
//          }
//
//          reader.close();
//       }
//
//    } catch (HttpException e) {
//       LOGGER.fatal(e.getMessage());
//    } catch (IOException e) {
//       LOGGER.fatal(e.getMessage());
//    } finally  {
//       getMethod.releaseConnection();
//    }
//
//    return contractHtml;
// }
//
 public int getResponceCode() {
    return responceCode;
 }
//
// public String getResponce() {
//    return responce;
// }
//
// public String getContentType() {
//    return contentType;
// }
//
// public String getUuid() {
//    return uuid;
// }

}
