package jp.savethememory.action;

import javax.annotation.Resource;

import jp.savethememory.dto.UserDto;
import jp.savethememory.entity.UserInfo;
import jp.savethememory.form.LoginForm;
import jp.savethememory.service.UserInfoService;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.seasar.framework.aop.annotation.Trace;
import org.seasar.struts.annotation.ActionForm;
import org.seasar.struts.annotation.Execute;

@Trace
public class LoginAction {

	public String message = null;
	public String breadCrumbListHTML = "";

	@Resource
	@ActionForm
	protected LoginForm loginForm;
	/** 認証情報を格納するためのセッションスコープのDTO */
	@Resource
	protected UserDto userDto;
	@Resource
	protected UserInfoService userInfoService;

	protected Log LOGGER = LogFactory.getLog(LoginAction.class);

	/** 　ログイン失敗時のメッセージ */
	private String LOGIN_ERROR_MESSAGE = "認証に失敗しました。アカウント又はパスワードが間違っています。";

	/** ログイン画面を表示する実行メソッド */
	@Execute(validator = false)
	public String index() {
		String returnPage = "loginForm.jsp";

		// セッションが既に存在する場合はログイン画面を表示せず次の画面へ遷移させる
		if (this.userDto != null) {
			if (this.userDto.account != null) {
				returnPage = "/pictureList/?redirect=true";
			}
		}

		return returnPage;
	}

	/**
	 * ログインボタンがクリックされた際に呼び出される実行メソッド
	 * 
	 **/
	@Execute(validator = true, input = "loginForm.jsp")
	public String login() {
		LOGGER.info("login start :----------------------");
		LOGGER.info("account :" + loginForm.account);
		// ログイン画面で入力されたアカウントとパスワードの確認をする
		UserInfo userInfo = userInfoService.getUserInfo(loginForm.account,
				loginForm.password);

		String returnPage;

		if (userInfo != null) {
			LOGGER.info("login success ----------------------");
			// ログイン成功
			// session情報を登録
			userDto.account = userInfo.getAccount();
			userDto.shichousonCode = userInfo.getShichousonCode();
			userDto.shichousonName = userInfo.getShichousonName();

			// ログイン後に表示する申請検索画面へ遷移
			returnPage = "/pictureList/?redirect=true";
		} else {
			LOGGER.info("login failure ----------------------");
			this.message = LOGIN_ERROR_MESSAGE;
			returnPage = "loginForm.jsp";
		}

		return returnPage;
	};

}
