package jp.savethememory.action;

import java.util.Calendar;

import javax.annotation.Resource;

import jp.savethememory.entity.TbShichouson;
import jp.savethememory.form.PhotoCounterForm;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.seasar.extension.jdbc.JdbcManager;
import org.seasar.framework.aop.annotation.Trace;
import org.seasar.struts.annotation.ActionForm;
import org.seasar.struts.annotation.Execute;

@Trace
public class PhotoCounterAction {
	public JdbcManager jdbcManager;

	@Resource
	@ActionForm
	protected PhotoCounterForm photoCounterForm;

	protected Log LOGGER = LogFactory.getLog(PhotoCounterAction.class);

	/**
	 * 現在の写真回収・返却状況を示す
	 * 
	 * @return
	 * @throws Exception
	 */
	@Execute(validator = false)
	public String index() {

		Calendar cal = Calendar.getInstance();
		photoCounterForm.currentYear = cal.get(Calendar.YEAR);
		photoCounterForm.currentMonth = cal.get(Calendar.MONTH) + 1;
		photoCounterForm.currentDate = cal.get(Calendar.DATE);
		photoCounterForm.shichousons = jdbcManager.from(TbShichouson.class)
				.orderBy("kenCode, shichousonCode").getResultList();
		return "index.jsp";
	}
}
