package jp.savethememory.entity;

import java.util.*;

/**
 * 検索条件が格納されるクラスです.
 * @see com.quanp.model.SearchContentCriteria
 */
public class SearchContentCriteria {
	private String text;
	private String title;
	private String tags;
	private String places;
	private Date createdFrom;
	private Date createdTo;
	private Date publishedFrom;
	private Date publishedTo;
	private Date updatedFrom;
	private Date updatedTo;
	private String nickname;
	private String filetype;
	private boolean hiddenEnable;
	
	public static final String KEYWORD_SPLIT_REGEX_AND = "[ \u3000\\+]";

	public String getText() {
		return text;
	}

	public void setText(String text) {
		this.text = text;
	}

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public String getTags() {
		return tags;
	}

	public void setTags(String tags) {
		this.tags = tags;
	}

	public String getPlaces() {
		return places;
	}

	public void setPlaces(String places) {
		this.places = places;
	}

	public Date getCreatedFrom() {
		return createdFrom;
	}

	public void setCreatedFrom(Date createdFrom) {
		this.createdFrom = createdFrom;
	}

	public Date getCreatedTo() {
		return createdTo;
	}

	public void setCreatedTo(Date createdTo) {
		this.createdTo = createdTo;
	}

	public Date getPublishedFrom() {
		return publishedFrom;
	}

	public void setPublishedFrom(Date publishedFrom) {
		this.publishedFrom = publishedFrom;
	}

	public Date getPublishedTo() {
		return publishedTo;
	}

	public void setPublishedTo(Date publishedTo) {

		this.publishedTo = publishedTo;
	}

	public Date getUpdatedFrom() {

		return updatedFrom;
	}

	public void setUpdatedFrom(Date updatedFrom) {

		this.updatedFrom = updatedFrom;
	}

	public Date getUpdatedTo() {

		return updatedTo;
	}

	public void setUpdatedTo(Date updatedTo) {

		this.updatedTo = updatedTo;
	}

	public String getNickname() {

		return nickname;
	}

	public void setNickname(String nickname) {

		this.nickname = nickname;
	}

	public String getFiletype() {

		return filetype;
	}

	public void setFiletype(String filetype) {

		this.filetype = filetype;
	}

	public boolean isHiddenEnable() {

		return hiddenEnable;
	}

	public void setHiddenEnable(boolean hiddenEnable) {

		this.hiddenEnable = hiddenEnable;
	}

}