package jp.savethememory.entity;

import java.sql.Timestamp;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.seasar.framework.aop.annotation.Trace;

@Trace
@Entity
@Table(name="tb_shinsei")
public class TbShinsei {

	@Column(name = "shichouson_code")
	private String shichousonCode;
	@Id
	@GeneratedValue(strategy=GenerationType.SEQUENCE,generator = "TbShinsei_GEN")
//	@SequenceGenerator(name="TbShinsei_GEN",sequenceName = "tb_shinsei_shinsei_no_seq")
	@SequenceGenerator(name="TbShinsei_GEN",sequenceName = "tb_shinsei_shinsei_no_seq",allocationSize=1)
//	@GeneratedValue(strategy=GenerationType.IDENTITY)
//	@Column(name = "shinsei_no")
	private Integer shinseiNo;
	@Column(name = "shinsei_name_sei")
	private String shinseiNameSei;
	@Column(name = "shinsei_name_mei")
	private String shinseiNameMei;
	@Column(name = "shinsei_furigana_sei")
	private String shinseiFuriganaSei;
	@Column(name = "shinsei_furigana_mei")
	private String shinseiFuriganaMei;
	@Column(name = "tel_no1")
	private String telNo1;
	@Column(name = "tel_no2")
	private String telNo2;
	@Column(name = "tel_no3")
	private String telNo3;
	@Temporal(TemporalType.DATE)
	private Date birthday;
	private Integer sex;
	@Column(name = "juuminhyou_jusho_zip_code")
	private String juuminhyouJushoZipCode;
	@Column(name = "juuminhyou_jusho_prefecture")
	private String juuminhyouJushoPrefecture;
	@Column(name = "juuminhyou_jusho_city")
	private String juuminhyouJushoCity;
	@Column(name = "juuminhyou_jusho_banti_gou")
	private String juuminhyouJushoBantiGou;
	@Column(name = "juuminhyou_jusho_tatemono")
	private String juuminhyouJushoTatemono;
	@Column(name = "gen_jusho_jusho_zip_code")
	private String genJushoJushoZipCode;
	@Column(name = "gen_jusho_jusho_prefecture")
	private String genJushoJushoPrefecture;
	@Column(name = "gen_jusho_jusho_city")
	private String genJushoJushoCity;
	@Column(name = "gen_jusho_jusho_banti_gou")
	private String genJushoJushoBantiGou;
	@Column(name = "gen_jusho_jusho_tatemono")
	private String genJushoJushoTatemono;
	@Column(name = "mail_address")
	private String mailAddress;
	@Column(name = "shinseisha_comment")
	private String shinseishaComment;
	@Column(name = "shinsei_status")
	private Integer shinseiStatus;
	@Column(name = "hikiwatashi_syudan")
	private Integer hikiwatashiSyudan;
	@Column(name = "staff_comment")
	private String staffComment;
	@Column(name = "quanp_id")
	private String quanpId;
	@Column(name = "quanp_password")
	private String quanpPassword;
	@Column(name = "quanp_id_status")
	private Integer quanpIdStatus;
	@Column(name = "digital_status")
	private Integer digitalStatus;
	@Temporal(TemporalType.DATE)
	@Column(name = "shinsei_day")
	private Date shinseiDay;
	@Temporal(TemporalType.DATE)
	@Column(name = "update_day")
	private Timestamp updateDay;

	public String getShichousonCode() {
		return shichousonCode;
	}

	public void setShichousonCode(String shichousonCode) {
		this.shichousonCode = shichousonCode;
	}

	public Integer getShinseiNo() {
		return shinseiNo;
	}

	public void setShinseiNo(Integer shinseiNo) {
		this.shinseiNo = shinseiNo;
	}

	public String getShinseiNameSei() {
		return shinseiNameSei;
	}

	public void setShinseiNameSei(String shinseiNameSei) {
		this.shinseiNameSei = shinseiNameSei;
	}

	public String getShinseiNameMei() {
		return shinseiNameMei;
	}

	public void setShinseiNameMei(String shinseiNameMei) {
		this.shinseiNameMei = shinseiNameMei;
	}

	public String getShinseiFuriganaSei() {
		return shinseiFuriganaSei;
	}

	public void setShinseiFuriganaSei(String shinseiFuriganaSei) {
		this.shinseiFuriganaSei = shinseiFuriganaSei;
	}

	public String getShinseiFuriganaMei() {
		return shinseiFuriganaMei;
	}

	public void setShinseiFuriganaMei(String shinseiFuriganaMei) {
		this.shinseiFuriganaMei = shinseiFuriganaMei;
	}

	public String getTelNo1() {
		return telNo1;
	}

	public void setTelNo1(String telNo1) {
		this.telNo1 = telNo1;
	}

	public String getTelNo2() {
		return telNo2;
	}

	public void setTelNo2(String telNo2) {
		this.telNo2 = telNo2;
	}

	public String getTelNo3() {
		return telNo3;
	}

	public void setTelNo3(String telNo3) {
		this.telNo3 = telNo3;
	}

	public Date getBirthday() {
		return birthday;
	}

	public void setBirthday(Date birthday) {
		this.birthday = birthday;
	}

	public Integer getSex() {
		return sex;
	}

	public void setSex(Integer sex) {
		this.sex = sex;
	}

	public String getJuuminhyouJushoZipCode() {
		return juuminhyouJushoZipCode;
	}

	public void setJuuminhyouJushoZipCode(String juuminhyouJushoZipCode) {
		this.juuminhyouJushoZipCode = juuminhyouJushoZipCode;
	}

	public String getJuuminhyouJushoPrefecture() {
		return juuminhyouJushoPrefecture;
	}

	public void setJuuminhyouJushoPrefecture(String juuminhyouJushoPrefecture) {
		this.juuminhyouJushoPrefecture = juuminhyouJushoPrefecture;
	}

	public String getJuuminhyouJushoCity() {
		return juuminhyouJushoCity;
	}

	public void setJuuminhyouJushoCity(String juuminhyouJushoCity) {
		this.juuminhyouJushoCity = juuminhyouJushoCity;
	}

	public String getJuuminhyouJushoBantiGou() {
		return juuminhyouJushoBantiGou;
	}

	public void setJuuminhyouJushoBantiGou(String juuminhyouJushoBantiGou) {
		this.juuminhyouJushoBantiGou = juuminhyouJushoBantiGou;
	}

	public String getJuuminhyouJushoTatemono() {
		return juuminhyouJushoTatemono;
	}

	public void setJuuminhyouJushoTatemono(String juuminhyouJushoTatemono) {
		this.juuminhyouJushoTatemono = juuminhyouJushoTatemono;
	}

	public String getGenJushoJushoZipCode() {
		return genJushoJushoZipCode;
	}

	public void setGenJushoJushoZipCode(String genJushoJushoZipCode) {
		this.genJushoJushoZipCode = genJushoJushoZipCode;
	}

	public String getGenJushoJushoPrefecture() {
		return genJushoJushoPrefecture;
	}

	public void setGenJushoJushoPrefecture(String genJushoJushoPrefecture) {
		this.genJushoJushoPrefecture = genJushoJushoPrefecture;
	}

	public String getGenJushoJushoCity() {
		return genJushoJushoCity;
	}

	public void setGenJushoJushoCity(String genJushoJushoCity) {
		this.genJushoJushoCity = genJushoJushoCity;
	}

	public String getGenJushoJushoBantiGou() {
		return genJushoJushoBantiGou;
	}

	public void setGenJushoJushoBantiGou(String genJushoJushoBantiGou) {
		this.genJushoJushoBantiGou = genJushoJushoBantiGou;
	}

	public String getGenJushoJushoTatemono() {
		return genJushoJushoTatemono;
	}

	public void setGenJushoJushoTatemono(String genJushoJushoTatemono) {
		this.genJushoJushoTatemono = genJushoJushoTatemono;
	}

	public String getMailAddress() {
		return mailAddress;
	}

	public void setMailAddress(String mailAddress) {
		this.mailAddress = mailAddress;
	}

	public String getShinseishaComment() {
		return shinseishaComment;
	}

	public void setShinseishaComment(String shinseishaComment) {
		this.shinseishaComment = shinseishaComment;
	}

	public Integer getShinseiStatus() {
		return shinseiStatus;
	}

	public void setShinseiStatus(Integer shinseiStatus) {
		this.shinseiStatus = shinseiStatus;
	}

	public Integer getHikiwatashiSyudan() {
		return hikiwatashiSyudan;
	}

	public void setHikiwatashiSyudan(Integer hikiwatashiSyudan) {
		this.hikiwatashiSyudan = hikiwatashiSyudan;
	}

	public String getStaffComment() {
		return staffComment;
	}

	public void setStaffComment(String staffComment) {
		this.staffComment = staffComment;
	}

	public String getQuanpId() {
		return quanpId;
	}

	public void setQuanpId(String quanpId) {
		this.quanpId = quanpId;
	}

	public String getQuanpPassword() {
		return quanpPassword;
	}

	public void setQuanpPassword(String quanpPassword) {
		this.quanpPassword = quanpPassword;
	}

	public Integer getQuanpIdStatus() {
		return quanpIdStatus;
	}

	public void setQuanpIdStatus(Integer quanpIdStatus) {
		this.quanpIdStatus = quanpIdStatus;
	}

	public Integer getDigitalStatus() {
		return digitalStatus;
	}

	public void setDigitalStatus(Integer digitalStatus) {
		this.digitalStatus = digitalStatus;
	}

	public Date getShinseiDay() {
		return shinseiDay;
	}

	public void setShinseiDay(Date shinseiDay) {
		this.shinseiDay = shinseiDay;
	}

	public Timestamp getUpdateDay() {
		return updateDay;
	}

	public void setUpdateDay(Timestamp updateDay) {
		this.updateDay = updateDay;
	}

}
