package jp.savethememory.entity;

import java.io.Serializable;
import java.sql.Timestamp;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.seasar.framework.aop.annotation.Trace;

@SuppressWarnings("serial")
@Trace
@Entity
@Table(name = "tb_syashin")
public class TbSyashin implements Serializable {

	@Id
	// @GeneratedValue
	@Column(name = "contents_id")
	private Long contentsId;
	@Column(name = "directory_name")
	private String directoryName;
	@Column(name = "file_name")
	private String fileName;
	@Column(name = "shinsei_no")
	private Long shinseiNo;
	@Column(name = "return_flg")
	private Boolean returnFlg;
	@Column(name = "quanp_upload_status")
	private Integer quanpUploadStatus;
	@Temporal(TemporalType.DATE)
	@Column(name = "published_day")
	private Timestamp publishedDay;
	@Column(name = "group_flg")
	private Boolean groupFlg;
	@Column(name = "public_flg")
	private Boolean publicFlg;
	@Column(name = "exclude_flg")
	private Boolean excludeFlg;
	@Column(name = "quanp_id")
	private String quanpId;
	@Column(name = "summary")
	private String summary;

	public String getQuanpId() {
		return quanpId;
	}

	public void setQuanpId(String quanpId) {
		this.quanpId = quanpId;
	}

	public Long getContentsId() {
		return contentsId;
	}

	public void setContentsId(Long contentsId) {
		this.contentsId = contentsId;
	}

	public String getDirectoryName() {
		return directoryName;
	}

	public void setDirectoryName(String directoryName) {
		this.directoryName = directoryName;
	}

	public String getFileName() {
		return fileName;
	}

	public void setFileName(String fileName) {
		this.fileName = fileName;
	}

	public Long getShinseiNo() {
		return shinseiNo;
	}

	public void setShinseiNo(Long shinseiNo) {
		this.shinseiNo = shinseiNo;
	}

	public Boolean getReturnFlg() {
		return returnFlg;
	}

	public void setReturnFlg(Boolean returnFlg) {
		this.returnFlg = returnFlg;
	}

	public Integer getQuanpUploadStatus() {
		return quanpUploadStatus;
	}

	public void setQuanpUploadStatus(Integer quanp_upload_status) {
		this.quanpUploadStatus = quanp_upload_status;
	}

	public Timestamp getPublishedDay() {
		return publishedDay;
	}

	public void setPublishedDay(Timestamp publishedDay) {
		this.publishedDay = publishedDay;
	}

	public Boolean getGroupFlg() {
		return groupFlg;
	}

	public void setGroupFlg(Boolean groupFlg) {
		this.groupFlg = groupFlg;
	}

	public Boolean getPublicFlg() {
		return publicFlg;
	}

	public void setPublicFlg(Boolean publicFlg) {
		this.publicFlg = publicFlg;
	}

	public Boolean getExcludeFlg() {
		return excludeFlg;
	}

	public void setExcludeFlg(Boolean excludeFlg) {
		this.excludeFlg = excludeFlg;
	}

	/**
	 * summaryをリターンする.
	 * 
	 * @return summary
	 */
	public String getSummary() {
		return summary;
	}

	/**
	 * summaryをセットする.
	 * 
	 * @param summary
	 *            summary フィールドにセットする summary
	 */
	public void setSummary(String summary) {
		this.summary = summary;
	}
}
