/*  Copyright© Ricoh IT Solutions Co.,Ltd.
 * All Rights Reserved.
 */
package jp.savethememory.entity;

import java.util.List;

 /**
 * TbSyashinのリストを持つクラスです.
 * TbSyashinのリストの長さと、totalResultsの値の違いは、
 * 検索結果1000件のうち20件をリストとして持っているなら、
 * <ul>
 * <li>TbSyashinのリストの長さは、実際に持っているリストの長さ20で、</li>
 * <li>totalResultの値は、検索結果の数1000です。</li>
 * </ul>
 *
 * @version 0.1
 * @since 2013/01/24
 */
public class TbSyashinList {

	/**
	 * TbSyashinのリスト.
	 * 2013/01/24現在はArrayListとして持たせることを想定.
	 */
	private List<TbSyashin> TbSyashinList;

	/**
	 * 検索結果の件数.
	 */
	private int totalResults;

	/**
	 * 保持しているリストに加えて更なる検索結果があるかどうか.
	 */
	private boolean hasNextSearchResult;

	/**
	 * tbSyashinListをリターンする.
	 * @return tbSyashinList
	 */
	public List<TbSyashin> getTbSyashinList() {
		return TbSyashinList;
	}

	/**
	 * tbSyashinListをセットする.
	 * @param tbSyashinList tbSyashinList フィールドにセットする tbSyashinList
	 */
	public void setTbSyashinList(List<TbSyashin> tbSyashinList) {
		TbSyashinList = tbSyashinList;
	}

	/**
	 * totalResultsをリターンする.
	 * @return totalResults
	 */
	public int getTotalResults() {
		return totalResults;
	}

	/**
	 * totalResultsをセットする.
	 * @param totalResults totalResults フィールドにセットする totalResults
	 */
	public void setTotalResults(int totalResults) {
		this.totalResults = totalResults;
	}

	/**
	 * hasNextSearchResultをリターンする.
	 * @return hasNextSearchResult 保持しているリストに加えて更なる検索結果があるかどうか.
	 */
	public boolean hasNext() {
		return hasNextSearchResult;
	}

	/**
	 * hasNextSearchResultをセットする.
	 * @param hasNext hasNextSearchResult フィールドにセットする hasNext
	 */
	public void setHasNextSearchResult(boolean hasNext) {
		this.hasNextSearchResult = hasNext;
	}


}
