package jp.savethememory.form;

import java.io.Serializable;
import java.util.List;

import jp.savethememory.entity.TbFace;
import jp.savethememory.entity.TbSyashin;
import jp.savethememory.entity.TbTag;

import org.apache.struts.upload.FormFile;
import org.seasar.framework.aop.annotation.Trace;
import org.seasar.framework.container.annotation.tiger.Component;
import org.seasar.framework.container.annotation.tiger.InstanceType;
import org.seasar.struts.annotation.Arg;
import org.seasar.struts.annotation.Mask;
import org.seasar.struts.annotation.Required;


@Trace
@Component(instance = InstanceType.SESSION)
public class PictureListForm implements Serializable {
	private static final long serialVersionUID = 1L;
	public int page;

	/** 検索条件選択 **/
	// 0：登録日検索　1：フリーワード検索
	public int searchCondition = 0;

	/** 検索条件:登録日 **/
	public int fromYear;
	public int fromMonth;
	public int fromDay;
	public int toYear;
	public int toMonth;
	public int toDay;

	/** 検索条件:フリーワード **/
	public String freeText = "";

	/** 検索条件：タグ **/
	public List<TbTag> tagList;
	public String tag = "";

	/** 検索条件:表示サイズ **/
	// 0：小　1：大
	public int pictureSize = 0;

	/** しおり検索用 **/
	@Mask(mask = "^[0-9]+$", arg0 = @Arg(key = "電話番号", resource = false, position = 0))
	@Required(arg0 = @Arg(key = "電話番号", resource = false, position = 0))
	public String bookmarkKey = "";

	/** コメント入力用 **/
	public String inputSummary;
	public String inputSummaryHidden;
	public String inputSummaryTargetContent;

	/** 選択コンテンツ用 **/
	public String selectedTitlePrefix = "";

	/** 選択枚数 **/
	public int selectedCount = 0;

	/** 一覧先頭ファイル名 **/
	public String displayStartFileName = "";

	/** しおり特定文字入力用 **/
	public String inputBookmarkKey = "";

	/** 遷移元(0:検索画面 1:一覧画面 2:送付先入力画面) **/
	public int from = 0;

	/** アルバム中身閲覧用 **/
	public String contentId = "";

	/** アルバム除外コンテンツリスト **/
	public String excludeContentIdList = "";

	/** アルバム除外コンテンツID **/
	public String excludeContentId;

	/** アルバム除外可能/不可能 **/
	public String canExclude;

	// 以下は可顔検索機能の追加コード
	public FormFile facePicture;

	public String facePictureContentId = "none";

	public String iconUrl;

	public int imageWidth;

	public List<TbFace> tbFaces;

	public String featureFilePath;

	/** 0はローカルからアップロード下写真　1はサーバー上のある写真 */
	public int pictureFrom;

	/** 0は普通の検索 1は顔検索 */
	public int searchType;

	public List<TbSyashin> verifyResults;

}
