package jp.savethememory.form;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import jp.savethememory.entity.TbSyashin;

import org.seasar.framework.aop.annotation.Trace;
import org.seasar.framework.container.annotation.tiger.Component;
import org.seasar.framework.container.annotation.tiger.InstanceType;
import org.seasar.struts.annotation.Arg;
import org.seasar.struts.annotation.DateType;
import org.seasar.struts.annotation.EmailType;
import org.seasar.struts.annotation.Mask;
import org.seasar.struts.annotation.Maxlength;
import org.seasar.struts.annotation.Msg;
import org.seasar.struts.annotation.Required;
import org.seasar.struts.annotation.Validwhen;

@Trace
@Component(instance=InstanceType.SESSION)
public class ShippingAddressForm implements Serializable{
	private static final long serialVersionUID = 1L;
	
	public int selectedCount;
	public int resultCount;
	public long shinseiNo;
	public boolean hasPublicContent;
	
	@Required(arg0=@Arg(key="姓",resource=false,position=0),target="confirm")
	public String lastName;
	@Required(arg0=@Arg(key="名",resource=false,position=0),target="confirm")
	public String firstName;
	@Required(arg0=@Arg(key="セイ",resource=false,position=0),target="confirm")
	public String lastNameKana;
	@Required(arg0=@Arg(key="メイ",resource=false,position=0),target="confirm")
	public String firstNameKana;
	@Mask(mask="^[0-9]+$",arg0=@Arg(key="電話番号（左）",resource=false,position=0),target="confirm")
	@Required(arg0=@Arg(key="電話番号（左）",resource=false,position=0),target="confirm")
	public String telNo1;
	@Mask(mask="^[0-9]+$",arg0=@Arg(key="電話番号（中）",resource=false,position=0),target="confirm")
	@Required(arg0=@Arg(key="電話番号（中）",resource=false,position=0),target="confirm")
	public String telNo2;
	@Mask(mask="^[0-9]+$",arg0=@Arg(key="電話番号（右）",resource=false,position=0),target="confirm")
	@Required(arg0=@Arg(key="電話番号（右）",resource=false,position=0),target="confirm")
	public String telNo3;
	
	@Mask(mask="^(19|20)[0-9]{2}+$",arg0=@Arg(key="年",resource=false,position=0),target="confirm")
	@Required(arg0=@Arg(key="年",resource=false,position=0),target="confirm")
	public String birthdayYear;
	@Mask(mask="^[0-9]{1,2}$",arg0=@Arg(key="月",resource=false,position=0),target="confirm")
	@Required(arg0=@Arg(key="月",resource=false,position=0),target="confirm")
	public String birthdayMonth;
	@Mask(mask="^[0-9]{1,2}$",arg0=@Arg(key="日",resource=false,position=0),target="confirm")
	@Required(arg0=@Arg(key="日",resource=false,position=0),target="confirm")
	public String birthdayDay;
	@Required(arg0=@Arg(key="性別",resource=false,position=0),target="confirm")
	public int sex = 0;
	
	//現住所
//	@Mask(mask="^[0-9]{3}$",arg0=@Arg(key="現住所 郵便番号(上3桁)",resource=false,position=0))
//	@Required(arg0=@Arg(key="現住所 郵便番号(上3桁)",resource=false,position=0))
//	public String presentZipcode_prefix;
//	@Mask(mask="^[0-9]{4}$",arg0=@Arg(key="現住所 郵便番号(下4桁)",resource=false,position=0))
//	@Required(arg0=@Arg(key="現住所 郵便番号(下4桁)",resource=false,position=0))
//	public String presentZipcode_suffix;
	@Mask(mask="^[0-9]{7}$",arg0=@Arg(key="現住所 郵便番号",resource=false,position=0),target="confirm,searchPresentAddress")
	@Required(arg0=@Arg(key="現住所 郵便番号",resource=false,position=0),target="confirm,searchPresentAddress")
	public String presentZipcode;
	@Required(arg0=@Arg(key="現住所 都道府県",resource=false,position=0),target="confirm")
	public String presentPrefecture;
	@Required(arg0=@Arg(key="現住所 市区郡町村",resource=false,position=0),target="confirm")
	public String presentCity;
	@Required(arg0=@Arg(key="現住所 番地・号",resource=false,position=0),target="confirm")
	public String presentAddress;
//	@Required(arg0=@Arg(key="現住所 建物・部屋番号",resource=false,position=0))
	public String presentBuilding;
	
	//住民票住所
	@Mask(mask="^[0-9]{7}$",arg0=@Arg(key="住民票住所 郵便番号",resource=false,position=0),target="confirm,searchResidenceCertAddress")
	@Required(arg0=@Arg(key="住民票住所 郵便番号",resource=false,position=0),target="searchResidenceCertAddress")
	public String residenceCertZipcode;
//	@Required(arg0=@Arg(key="住民票住所 都道府県",resource=false,position=0))
	public String residenceCertPrefecture;
//	@Required(arg0=@Arg(key="住民票住所 市区郡町村",resource=false,position=0))
	public String residenceCertCity;
//	@Required(arg0=@Arg(key="住民票住所 番地・号",resource=false,position=0))
	public String residenceCertAddress;
//	@Required(arg0=@Arg(key="住民票住所 建物・部屋番号",resource=false,position=0))
	public String residenceCertBuilding;
	
	@EmailType(arg0=@Arg(key="メールアドレス",resource=false,position=0),target="confirm")
	@Validwhen(test="(*this* == retypeMail)",msg=@Msg(key="メールアドレス（再入力）と異なります。",resource=false),target="confirm")
	public String mail;
	@EmailType(arg0=@Arg(key="メールアドレス(再入力)",resource=false,position=0),target="confirm")
	public String retypeMail;
	public String message;
	public List<TbSyashin> publicSyashinList;
	
	//送付先履歴検索用情報
	@Mask(mask="^[0-9]+$",arg0=@Arg(key="電話番号（左）",resource=false,position=0),target="searchShippingAddressHistory")
	@Required(arg0=@Arg(key="電話番号（左）",resource=false,position=0),target="searchShippingAddressHistory")
	public String searchTelNo1;
	@Mask(mask="^[0-9]+$",arg0=@Arg(key="電話番号（中）",resource=false,position=0),target="searchShippingAddressHistory")
	@Required(arg0=@Arg(key="電話番号（中）",resource=false,position=0),target="searchShippingAddressHistory")
	public String searchTelNo2;
	@Mask(mask="^[0-9]+$",arg0=@Arg(key="電話番号（右）",resource=false,position=0),target="searchShippingAddressHistory")
	@Required(arg0=@Arg(key="電話番号（右）",resource=false,position=0),target="searchShippingAddressHistory")
	public String searchTelNo3;
	@Mask(mask="^(19|20)[0-9]{2}+$",arg0=@Arg(key="年",resource=false,position=0),target="searchShippingAddressHistory")
	@Required(arg0=@Arg(key="年",resource=false,position=0),target="searchShippingAddressHistory")
	public String searchBirthdayYear;
	@Mask(mask="^[0-9]{1,2}$",arg0=@Arg(key="月",resource=false,position=0),target="searchShippingAddressHistory")
	@Required(arg0=@Arg(key="月",resource=false,position=0),target="searchShippingAddressHistory")
	public String searchBirthdayMonth;
	@Mask(mask="^[0-9]{1,2}$",arg0=@Arg(key="日",resource=false,position=0),target="searchShippingAddressHistory")
	@Required(arg0=@Arg(key="日",resource=false,position=0),target="searchShippingAddressHistory")
	public String searchBirthdayDay;
	
	
	public void init(){
		lastName = null;
		firstName = null;
		lastNameKana = null;
		firstNameKana = null;
		telNo1 = null;
		telNo2 = null;
		telNo3 = null;
		birthdayYear = null;
		birthdayMonth = null;
		birthdayDay = null;
		sex = 0;
		presentZipcode = null;
		presentPrefecture = null;
		presentCity = null;
		presentAddress = null;
		presentBuilding = null;
		residenceCertZipcode = null;
		residenceCertPrefecture = null;
		residenceCertCity = null;
		residenceCertAddress = null;
		residenceCertBuilding = null;	
		mail = null;
		retypeMail = null;
		message = null;
		
		searchTelNo1 = null;
		searchTelNo2 = null;
		searchTelNo3 = null;
		searchBirthdayYear = null;
		searchBirthdayMonth = null;
		searchBirthdayDay = null;
	}
}
