/*  Copyright© Ricoh IT Solutions Co.,Ltd.
 * All Rights Reserved.
 */
package jp.savethememory.service;

import java.util.List;

import jp.savethememory.entity.TbSyashin;
import jp.savethememory.entity.TbTag;

import org.seasar.extension.jdbc.JdbcManager;

/**
 *
 * @version 0.1
 * @since 2013/01/18
 */
public class StorageService {

	public JdbcManager jdbcManager;

	/**
	 * tb_tagテーブルから、quanp_idに対応するタグのリストを取得するメソッドです.
	 * タグを、frequency（出現頻度）で降順にソートしています.
	 *
	 * @param quanpId
	 *            各自治体のクオンプID.
	 * @return 引数quanpIdが保持している写真に紐づけられたタグのリストで、同じ名称のタグはgrou byしてあります.
	 */
	public List<TbTag> loadTagList(String quanpId) {

		List<TbTag> tagList = jdbcManager.selectBySqlFile(TbTag.class,
				"sql/tb_tag/loadTagList.sql", quanpId).getResultList();

		return tagList;
	}

	/**
	 * TbSyashinを更新するメソッドです.
	 *
	 * @param tbSyashin
	 *            更新対象の写真
	 */
	public int updateTbSyashin(TbSyashin tbSyashin) {
		return jdbcManager.update(tbSyashin).execute();

	}
}
