package jp.savethememory.util;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class ExceptionFilter implements Filter{

	protected Log LOGGER = LogFactory.getLog(ExceptionFilter.class);
	private ServletContext context;
	
	@Override
	public void doFilter(ServletRequest request, ServletResponse response, FilterChain filterChain) 
	throws IOException, ServletException {
		try {
			filterChain.doFilter(request, response);
			
		} catch (Exception ex){
			LOGGER.error("SYSTEM ERROR",ex);
			
			RequestDispatcher dispatcher = context.getRequestDispatcher("/WEB-INF/view/common/error.jsp");
			dispatcher.forward(request, response);
		}
	}
	
	@Override
	public void init(FilterConfig config) throws ServletException {
		this.context = config.getServletContext();
	}
	
	@Override
	public void destroy(){
		
	}
	
}
